/*
complex13.h
*/

#include "complex.h"

// sum = c01 + ... + c13
static inline d_complex_t d_add13(
	d_complex_t c01, d_complex_t c02, d_complex_t c03, d_complex_t c04, d_complex_t c05,
	d_complex_t c06, d_complex_t c07, d_complex_t c08, d_complex_t c09, d_complex_t c10,
	d_complex_t c11, d_complex_t c12, d_complex_t c13)
{
	return d_complex(
		c01.r + c02.r + c03.r + c04.r + c05.r + c06.r + c07.r + c08.r + c09.r + c10.r + c11.r + c12.r + c13.r,
		c01.i + c02.i + c03.i + c04.i + c05.i + c06.i + c07.i + c08.i + c09.i + c10.i + c11.i + c12.i + c13.i);
}


// c[] = a
static inline void d_set13(d_complex_t c[], d_complex_t a)
{
	c[ 0] = c[ 1] = c[ 2] = c[ 3] = c[ 4] =
	c[ 5] = c[ 6] = c[ 7] = c[ 8] = c[ 9] =
	c[10] = c[11] = c[12] = a;
}


// a[] = s * b[]
static inline void d_scal13(d_complex_t a[], const d_complex_t b[], d_complex_t s)
{
	a[ 0] = d_mul(s, b[ 0]);
	a[ 1] = d_mul(s, b[ 1]);
	a[ 2] = d_mul(s, b[ 2]);
	a[ 3] = d_mul(s, b[ 3]);
	a[ 4] = d_mul(s, b[ 4]);
	a[ 5] = d_mul(s, b[ 5]);
	a[ 6] = d_mul(s, b[ 6]);
	a[ 7] = d_mul(s, b[ 7]);
	a[ 8] = d_mul(s, b[ 8]);
	a[ 9] = d_mul(s, b[ 9]);
	a[10] = d_mul(s, b[10]);
	a[11] = d_mul(s, b[11]);
	a[12] = d_mul(s, b[12]);
}

/*
// a[] * b[]
static inline d_complex_t d_dot13(
	d_complex_t a01, d_complex_t a02, d_complex_t a03, d_complex_t a04, d_complex_t a05,
	d_complex_t a06, d_complex_t a07, d_complex_t a08, d_complex_t a09, d_complex_t a10,
	d_complex_t a11, d_complex_t a12, d_complex_t a13,
	d_complex_t b01, d_complex_t b02, d_complex_t b03, d_complex_t b04, d_complex_t b05,
	d_complex_t b06, d_complex_t b07, d_complex_t b08, d_complex_t b09, d_complex_t b10,
	d_complex_t b11, d_complex_t b12, d_complex_t b13)
{
	d_complex_t ret;
	ret.r =
		(a01.r * b01.r) - (a01.i * b01.i) +
		(a02.r * b02.r) - (a02.i * b02.i) +
		(a03.r * b03.r) - (a03.i * b03.i) +
		(a04.r * b04.r) - (a04.i * b04.i) +
		(a05.r * b05.r) - (a05.i * b05.i) +
		(a06.r * b06.r) - (a06.i * b06.i) +
		(a07.r * b07.r) - (a07.i * b07.i) +
		(a08.r * b08.r) - (a08.i * b08.i) +
		(a09.r * b09.r) - (a09.i * b09.i) +
		(a10.r * b10.r) - (a10.i * b10.i) +
		(a11.r * b11.r) - (a11.i * b11.i) +
		(a12.r * b12.r) - (a12.i * b12.i) +
		(a13.r * b13.r) - (a13.i * b13.i);

	ret.i =
		(a01.r * b01.i) + (a01.i * b01.r) +
		(a02.r * b02.i) + (a02.i * b02.r) +
		(a03.r * b03.i) + (a03.i * b03.r) +
		(a04.r * b04.i) + (a04.i * b04.r) +
		(a05.r * b05.i) + (a05.i * b05.r) +
		(a06.r * b06.i) + (a06.i * b06.r) +
		(a07.r * b07.i) + (a07.i * b07.r) +
		(a08.r * b08.i) + (a08.i * b08.r) +
		(a09.r * b09.i) + (a09.i * b09.r) +
		(a10.r * b10.i) + (a10.i * b10.r) +
		(a11.r * b11.i) + (a11.i * b11.r) +
		(a12.r * b12.i) + (a12.i * b12.r) +
		(a13.r * b13.i) + (a13.i * b13.r);

	return ret;
}
*/

/*
static inline d_complex_t d_dot13(const d_complex_t a[], const d_complex_t b[])
{
	return d_complex(
		(a[ 0].r * b[ 0].r) - (a[ 0].i * b[ 0].i) +
		(a[ 1].r * b[ 1].r) - (a[ 1].i * b[ 1].i) +
		(a[ 2].r * b[ 2].r) - (a[ 2].i * b[ 2].i) +
		(a[ 3].r * b[ 3].r) - (a[ 3].i * b[ 3].i) +
		(a[ 4].r * b[ 4].r) - (a[ 4].i * b[ 4].i) +
		(a[ 5].r * b[ 5].r) - (a[ 5].i * b[ 5].i) +
		(a[ 6].r * b[ 6].r) - (a[ 6].i * b[ 6].i) +
		(a[ 7].r * b[ 7].r) - (a[ 7].i * b[ 7].i) +
		(a[ 8].r * b[ 8].r) - (a[ 8].i * b[ 8].i) +
		(a[ 9].r * b[ 9].r) - (a[ 9].i * b[ 9].i) +
		(a[10].r * b[10].r) - (a[10].i * b[10].i) +
		(a[11].r * b[11].r) - (a[11].i * b[11].i) +
		(a[12].r * b[12].r) - (a[12].i * b[12].i),
		(a[ 0].r * b[ 0].i) + (a[ 0].i * b[ 0].r) +
		(a[ 1].r * b[ 1].i) + (a[ 1].i * b[ 1].r) +
		(a[ 2].r * b[ 2].i) + (a[ 2].i * b[ 2].r) +
		(a[ 3].r * b[ 3].i) + (a[ 3].i * b[ 3].r) +
		(a[ 4].r * b[ 4].i) + (a[ 4].i * b[ 4].r) +
		(a[ 5].r * b[ 5].i) + (a[ 5].i * b[ 5].r) +
		(a[ 6].r * b[ 6].i) + (a[ 6].i * b[ 6].r) +
		(a[ 7].r * b[ 7].i) + (a[ 7].i * b[ 7].r) +
		(a[ 8].r * b[ 8].i) + (a[ 8].i * b[ 8].r) +
		(a[ 9].r * b[ 9].i) + (a[ 9].i * b[ 9].r) +
		(a[10].r * b[10].i) + (a[10].i * b[10].r) +
		(a[11].r * b[11].i) + (a[11].i * b[11].r) +
		(a[12].r * b[12].i) + (a[12].i * b[12].r));
}
*/
