/*
outputCross.c

output cross section
*/

#include "oth.h"
#include "complex.h"
#include "oth_prototype.h"

static void _outputCross(FILE *fp)
{
	// setup
	setup_farfield();

	// far field factor
	double *ffctr = (double *)malloc(NFrequency * sizeof(double));
	farfactor(ffctr);

	fprintf(fp, "%s\n", "=== cross section ===");
	fprintf(fp, "  %s\n", "frequency[Hz] backward[m*m]    forward[m*m]");
	for (int ifreq = 0; ifreq < NFrequency; ifreq++) {
		d_complex_t etheta, ephi;
		farfield(ifreq, Planewave.theta, Planewave.phi, ffctr[ifreq], &etheta, &ephi);
		double sb = d_norm(etheta) + d_norm(ephi);
		farfield(ifreq, 180 - Planewave.theta, 180 + Planewave.phi, ffctr[ifreq], &etheta, &ephi);
		double sf = d_norm(etheta) + d_norm(ephi);
		fprintf(fp, "%13.5e%16.5e%16.5e\n", Frequency[ifreq], sb, sf);
	}

	fflush(fp);
}

void outputCross(FILE *fp)
{
	_outputCross(stdout);
	_outputCross(fp);
}
